var collisionLinesList = new Array();
var collisionLinesCoeficients;
var collisionLinesCount;

var lastX;
var lastY;

function initColisionObjects(){
   var colision = SVGDoc.getElementById("colision");
   var colisionObjects = colision.childNodes;
   for(var i = 0; i < colisionObjects.length; ++i){
      var segList = colisionObjects[i].pathSegList;
      if(segList){
      	lastX = 0.0;
        lastY = 0.0;
        addSegmentsToCollisionLinesList(segList);
      }    
   }
   collisionLinesCount = collisionLinesList.length >> 2;
   showLineList();
   console.log("linecount" + collisionLinesCount +"\n");
   getCoefs();
   showCoefList();
}

function addSegmentsToCollisionLinesList(segList){
   var newX;
   var newY;
   var listPos = collisionLinesList.length;
   
   for(var i = 0; i < segList.numberOfItems; ++i){
      var pathSeg = segList.getItem(i);
      var type = pathSeg.pathSegType;
      if(type == SVGPathSeg.PATHSEG_MOVETO_ABS){
          lastX = pathSeg.x;
          lastY = pathSeg.y;
          console.log("moveto\n");
      } else if(type == SVGPathSeg.PATHSEG_MOVETO_REL){
          lastX += pathSeg.x;
          lastY += pathSeg.y;
          console.log("movetorel\n");
      } else if(type == SVGPathSeg.PATHSEG_LINETO_ABS){
          newX = pathSeg.x;
          newY = pathSeg.y;
          addLineToList(lastX, lastY, newX, newY);
          lastX = newX;
          lastY = newY;
          console.log("lineto\n");
      } else if(type == SVGPathSeg.PATHSEG_LINETO_REL){
          newX = lastX + pathSeg.x;
          newY = lastY + pathSeg.y;
          addLineToList(lastX, lastY, newX, newY);
          console.log("linetorel\n");
      } else if(type == SVGPathSeg.PATHSEG_LINETO_HORIZONTAL_ABS){
      	  newX = pathSeg.x;
      	  addLineToList(lastX, lastY, newX, lastY);
      	  console.log("linehorizontal\n");
      } else if(type == SVGPathSeg.PATHSEG_LINETO_HORIZONTAL_REL){
      	  newX = lastX + pathSeg.x;
      	  addLineToList(lastX, lastY, newX, lastY);
      	  console.log("linehorizontalrel\n");
      } else if(type == SVGPathSeg.PATHSEG_LINETO_VERTICAL_ABS){
      	  newY = pathSeg.y;
      	  addLineToList(lastX, lastY, lastX, newY);
      	  console.log("linevertical\n");
      } else if(type == SVGPathSeg.PATHSEG_LINETO_VERTICAL_REL){
      	  newY = lastY + pathSeg.y;
      	  addLineToList(lastX, lastY, lastX, newY);
      	  console.log("lineverticalrel\n");
      } else if(type == SVGPathSeg.PATHSEG_CLOSEPATH){
          addClosePathToList(listPos);
          console.log("closepath\n");
      }else{
      console.log("unknown\n");
      }
   }
   console.log("item");
}

function showLineList(){
    console.log("line list:");
    for(var i = 0; i < collisionLinesList.length; i += 4){
        console.log("line x1: " + collisionLinesList[i] + " y1: " + collisionLinesList[i + 1] + " x2: " + collisionLinesList[i + 2] + " y2: " + collisionLinesList[i + 3]);
    }
}

function getCoefs(){
    collisionLinesCoeficients = new Array(collisionLinesCount * 3);
    for(var i = 0; i < collisionLinesCount; ++i){
          var index = i << 2;
	  var x1 = collisionLinesList[index];
	  var y1 = collisionLinesList[index + 1];
	  var x2 = collisionLinesList[index + 2];
	  var y2 = collisionLinesList[index + 3];
	  var a = y2 - y1;  // dy
	  var b = x1 - x2;  // -dx
	  var lngth = Math.sqrt(a * a + b * b);
	  a /= lngth;
	  b /= lngth;
	  var c = - a * x1 - b * y1;
	  var index2 = i * 3;
	  collisionLinesCoeficients[index2] = a;
	  collisionLinesCoeficients[index2 + 1] = b;
	  collisionLinesCoeficients[index2 + 2] = c;
    }
}

function showCoefList(){
    for(var i = 0; i < collisionLinesCoeficients.length; i += 3){
        console.log("line a: " + collisionLinesCoeficients[i] + " b: " + collisionLinesCoeficients[i + 1] + " c: " + collisionLinesCoeficients[i + 2]);
    }
}

function addLineToList(x1, y1, x2, y2){
	var index = collisionLinesList.length;
	collisionLinesList[index] = x1;
	collisionLinesList[index + 1] = y1;
	collisionLinesList[index + 2] = x2;
	collisionLinesList[index + 3] = y2;
	lastX = x2;
	lastY = y2;
        console.log("line x1: " + x1 + " y1: " + y1 + " x2: " + x2 + " y2: " + y2 + "\n");
}

function addClosePathToList(startIndex){
       var index = collisionLinesList.length;
       addLineToList(collisionLinesList[index - 2], collisionLinesList[index - 1], collisionLinesList[startIndex], collisionLinesList[startIndex + 1]);
}


