var DOCount = 0;
var tmpVec = new Array(2);

function DynamicObject(){
  this.setPosition(0, 0);
  this.setAcceleration(0, 0);
  this.setVelocity(0, 0);
  this.radius = 10;
  this.coeficientOfRestitution = 0.8;
}

function initDynamicObjectDef(){
  DynamicObject.prototype.setPosition = setPositionDO;
  DynamicObject.prototype.setAcceleration = setAccelerationDO;
  DynamicObject.prototype.setVelocity = setVelocityDO;
  DynamicObject.prototype.simulate = simulateDO;
  DynamicObject.prototype.initFromElement = initFromElementDO;
  DynamicObject.prototype.updateGraphics = updateGraphicsDO;
  DynamicObject.prototype.solveCollision = solveCollision;
  DynamicObject.prototype.setStartingPos = setStartingPosDO;
}

// načte pozici pozici kruhového objektu ze svg a nahradí zdrojový element novým
function initFromElementDO(obj){
  var segList = obj.pathSegList;
  var pathSeg = segList.getItem(0);
  tmpVec[0] = pathSeg.x;
  tmpVec[1] = pathSeg.y;
  processTransforms(tmpVec, obj);
  this.posX = tmpVec[0] - 10.0;
  this.posY = tmpVec[1];
  this.startingPosX = this.posX;
  this.startingPosY = this.posY;
  this.svgObject = SVGDoc.createElementNS(svgns, "circle"); 
  this.svgObject.setAttribute("cx", this.posX);  
  this.svgObject.setAttribute("cy", this.posY);  
  this.svgObject.setAttribute("r", 10);   
  this.svgObject.setAttribute("fill", "red");
  dynamicLayer.replaceChild(this.svgObject, obj);
}

// provede aktualizaci pozice v svg souboru
function updateGraphicsDO(){
   this.svgObject.setAttribute("cx", this.posX);  
   this.svgObject.setAttribute("cy", this.posY);  
}

// provede aktualizaci pozice v svg souboru
function setStartingPosDO(){
   this.svgObject.setAttribute("cx", this.posX);  
   this.svgObject.setAttribute("cy", this.posY);
   this.posX = this.startingPosX;
   this.posY = this.startingPosY;
}


// nastavení veličin objektu

function setPositionDO(x, y){
  this.posX = x;
  this.posY = y;
}

function setAccelerationDO(x, y){
  this.accelX = x;
  this.accelY = y;
}

function setVelocityDO(x, y){
  this.velX = x;
  this.velY = y;
}

// provede časový krok s vyřešením kolizí
function simulateDO(dt){	
  var velocityX = this.velX + this.accelX * dt;
  var velocityY = this.velY + this.accelY * dt;
  var positionX = this.posX + velocityX * dt;
  var positionY = this.posY + velocityY * dt;
  
  this.velX = velocityX;
  this.velY = velocityY;
    
  var collisionFound = false;
  
  // parametry kolizní přímky
  var collisionA;
  var collisionB;
  var collisionC;
  var collisionCorrectionX;
  var collisionCorrectionY;
   
  // cyklus pro všechny kolizní úsečky
  for(var i = 0; i < collisionLinesCount; ++i){
      // testovací přímka
      var index = 3 * i;
      var a = collisionLinesCoeficients[index];
      var b = collisionLinesCoeficients[index + 1];
      var c = collisionLinesCoeficients[index + 2];
      
      // koncové body
      var index2 = i << 2;
      var x1 = collisionLinesList[index2];
      var y1 = collisionLinesList[index2 + 1];
      var x2 = collisionLinesList[index2 + 2];
      var y2 = collisionLinesList[index2 + 3];
      
      // minima maxima
      var minX = Math.min(x1, x2);
      var minY = Math.min(y1, y2);
      var maxX = Math.max(x1, x2);
      var maxY = Math.max(y1, y2);
      
      // vzdálenost od testovací přímky
      var distance = getDistance(positionX, positionY, a, b, c);
      var absDistance = Math.abs(distance);
      
      if(absDistance < this.radius){     	      
          var circleC = getC(positionX, positionY, -b, a);
          var testColisionTypeB = false;
          var endpointX;
          var endpointY;
          if(a > b){ // kolizní přímka má blíže k vodorovné (kontrola kolize typu A proběhne v souřanici X)
             var circleX = getLineIntersectionX(a, b, c, -b, a, circleC);
             if(circleX < minX || circleX > maxX){ // kolize typu A nenastala
               endpointX = circleX < minX ? minX : maxX; // zjištění bližšího krajního bodu (souřadnice X)
               endpointY = getLineYFromX(endpointX, a, b, c); // dopočítání Y
               testColisionTypeB = true;
             }   
          } else { //  kolizní přímka má blíže k svislé (kontrola kolize typu A proběhne v souřanici Y)
              var circleY = getLineIntersectionY(a, b, c, -b, a, circleC);
             if(circleY < minY || circleY > maxY){
              endpointY = circleY < minY ? minY : maxY;
              endpointX = getLineXFromY(endpointY, a, b, c);
              testColisionTypeB = true;
             }  
          }
          if(testColisionTypeB){ // kolize A nenastala (provedení testu na typ B)
              a = -endpointX + positionX;
              b = -endpointY + positionY;
              var lngth = getVectorLength(a,b);
              if(lngth > this.radius){
                continue; // bez kolize
              }
              // vytvoření náhradní kolizní přímky
              a /= lngth;
	      b /= lngth;
              c = getC(endpointX, endpointY, a, b);
              distance = getDistance(positionX, positionY, a, b, c);
              absDistance = Math.abs(distance);  
          }
        
        var correction = (this.radius - absDistance) * sgn(distance);
        var correctionX = correction * a;
        var correctionY = correction * b;
     
        // zjištění jestli je kolize první nalezená
        if(collisionFound){ 
           var correctedX1 = positionX + correctionX;
           var correctedY1 = positionY + correctionY;
           var c1 = getC(correctedX1, correctedY1, a, b);
           
           var correctedX2 = positionX + collisionCorrectionX;
           var correctedY2 = positionY + collisionCorrectionY;
           var c2 = getC(correctedX2, correctedY2, collisionA, collisionB);
           
           // detekce shodných kolizních přímek
           if(collisionA - a > 0.00001){ // kvůli zaokrouhlovacím chybám
             // kolizní přímky nejsou shodné
             // vyřešení posloupnosti kolizí
             var velocityA = this.velY;
             var velocityB = -this.velX;
             var velocityC = getC(positionX, positionY, velocityA, velocityB);
             getIntersection(tmpVec, a, b, c1, velocityA, velocityB, velocityC);	   
             var intersectionX1 = tmpVec[0];
             var intersectionY1 = tmpVec[1];
             getIntersection(tmpVec, collisionA, collisionB, c2, velocityA, velocityB, velocityC);	   
             var intersectionX2 = tmpVec[0];
             var intersectionY2 = tmpVec[1];
             
             var lngth1 = getLength = (intersectionX1 - positionX, intersectionY1 - positionY);
             var lngth2 = getLength = (intersectionX2 - positionX, intersectionY2 - positionY);
             
             // vyřešení první kolize (kolizní parametry nastaveny na druhou -> vykonáno za cyklem)
             if(lngth1 > lngth2){
               this.solveCollision(positionX, positionY, a, b, correctedX1, correctedY1);
               break; // 
             }
             this.solveCollision(positionX, positionY, collisionA, collisionB, correctedX2, correctedY2);
             collisionA = a;
             collisionB = b;
             collisionC = c;
             collisionCorrectionX = correctionX
             collisionCorrectionY = correctionY;
             break;
           }
           continue;
        }
        collisionFound = true;
        collisionA = a;
        collisionB = b;
        collisionC = c;
        collisionCorrectionX = correctionX;
        collisionCorrectionY = correctionY;
      }
  }
  if(collisionFound){ // kolize nalezen -> vyřešení
      this.solveCollision(positionX, positionY, collisionA, collisionB, collisionCorrectionX, collisionCorrectionY);
      return;
  }
  // kolize nenastala nastavení nových souřadnic nekolizní dráhy
  this.posX = positionX;
  this.posY = positionY;
}

// provedení reakce na kolizi
function solveCollision(positionX, positionY, normalX, normalY, collisionCorrectionX, collisionCorrectionY) {	  
      var collisionVelocity =  (normalX * this.velX + normalY * this.velY);
      var collisionVelocityX = collisionVelocity * normalX;
      var collisionVelocityY = collisionVelocity * normalY;
      this.velX -= collisionVelocityX * (1.0 + this.coeficientOfRestitution);
      this.velY -= collisionVelocityY * (1.0 + this.coeficientOfRestitution);
      
      this.posX = positionX + collisionCorrectionX * (1.0 + this.coeficientOfRestitution);
      this.posY = positionY + collisionCorrectionY * (1.0 + this.coeficientOfRestitution);
}

// pomocné funkce
function sgn(val){
    return val >= 0.0 ? 1.0 : -1.0; 
}

function getDistance(x, y, a, b, c){
    return a * x + b * y + c;
}

function getVectorLength(x, y) {
    return Math.sqrt(x * x + y * y);
}

function getLineIntersectionX(a1, b1, c1, a2, b2, c2){
    return (b1 * c2 - c1 * b2) / (a1 * b2 - b1 * a2);
}

function getLineIntersectionY(a1, b1, c1, a2, b2, c2){
    return (a1 * c2 - c1 * a2) / (b1 * a2 - a1 * b2);
}

function getLineYFromX(x, a, b, c){
    return -(a * x + c) / b;
}

function getLineXFromY(x, a, b, c){
    return -(b * x + c) / a;
}

function getIntersection(point, a1, b1, c1, a2, b2, c2){
    var x;
    var y;
    if(b1 > 0.707){
      x = (b1 * c2 - c1 * b2) / (a1 * b2 - b1 * a2);
      y =  -(a1 * x + c1) / b1;
    } else {
      y = (a1 * c2 - c1 * a2) / (b1 * a2 - a1 * b2);
      x =  -(b1 * x + c1) / a1;
    }
    point[0] = x;
    point[1] = y;
}

function getC(x, y, a, b){
    return -a * x - b * y;;
}


// vytvoří úsečku (nepoužito)
function createLine(x1, y1, x2, y2){
      var line = SVGDoc.createElementNS(svgns,"line"); 
      line.setAttribute("x1", x1); 
      line.setAttribute("y1", y1); 
      line.setAttribute("x2", x2); 
      line.setAttribute("y2", y2); 
      line.setAttribute("width", 1); 
      line.setAttribute("stroke","rgb(255,0,0)"); 
      return line;
}
