// SIMULATION PARAMETERS
cfgSimulationEnabled = true;
cfgStepping = false;
cfgStepsPerFrame = 10; // množství integrovaných časových úseků za jeden snímek
cfgIntegrator = "NSV"; // RK4 || NSV || Euler || SineWave (falešný, na testování)
cfgLog2Size = 6; // (min. 1, max. 8) vlajka je tvořena n x n hmotnými body přičemž  n = 2 ^ cfgLog2Size

cfgDimension = 1.0; // [m]
cfgDensity = 0.175; // [kg/m^2] hmotnost látky vlajky na m^2

//      ___________    _________
//   ->|           |<-          |
// f ->|           |<- f  <- F  h     
//   ->|___________|<- _________|
//     |___L0___|  |
//     |____L______|
//  f = F / h [N/m] - liniová síla; L0 - neutrální délka
//
// elasticita: změna linové síly na hraně při poměrném prodloužení
cfgElasticityStructural = 3.5;  // [N/m] = f / ( L - L0 /  L0)   // ve vodorovném/svislém směru
cfgElasticityShear = 3.5; // [N/m] -||- // v diagonálním směru
cfgElasticityBend = 1.5;      // [N/m] -||- // "ob jeden hm. bod" -> odpor proti kroucení

// tlumení
cfgDampingStructural = 0.0001;  // [-]  ve vodorovném/svislém směru
cfgDampingShear = 0.0001; // [-]  v diagonálním směru
cfgDampingBend = 0.0001;     // [-]  "ob jeden hm. bod" -> tlumení při kroucení

cfgWindSpeed = 4.5; // [m/s] rychlost větru v m.s^-1
//cfgElementCx = 1.0; // [-] koef. odporu vzduchu elementů vlajky

// EXTENSIONS
// standartně jsou použity všechny dostupné extensiony, jejich používání lze zde vypnout
textureFloatDisable = false; // vypne používání extensionu OES_texture_float
vertexTextureDisable = false; // vypne používání Textur (Samplerů) ve vertex shaderech

// DEBUG
useWebGLDebugUtils = false; // použití GLDebug util pro podrobnější zprávu k GL Errorům
useWebGLDebugContext = false; // obalení gl contextu debug contextem z externí knihovny (není potřeba pro funkčnost žádných dalších možností)

debugMode = true; // globální zapnutí debug modu (vypne/zapne celý strom dále)
  debugSupportedExtensionsList = true; // seznam podporovaných extensionů
  debugCheckExtensions = true;
  
  debugShaders = true; // debugování GLSL shaderů
    debugShadersSource = true; // zobrazení zdrojového kódu
    debugShadersType = true;
    debugShadersCompileStatus = true; // zobrazení výsledku kompilace
    debugShadersInfoLog = true;
    debugShadersGLError = true;
    
  debugPrograms = true; // debugování GLSL programů
    debugProgramsLinkStatus = true; // zobrazení výsledku linkování
      debugProgramsLinkInfoLog = true;
    debugProgramsValidateStatus = false;
      debugProgramsValidateInfoLog = true;
    debugProgramsGLError = true;
    
  debugFPS = false; // periodicky vypisuje počet snímků za sekundu do konzole
  
// neimplementováno
// RGB565 - konfigurace převodu hodnot vektorových polí do formátu RGB565 a nazpět (tzn. pokud není použit OES_texture_float)
defaultPositionOffset = 0.5;
defaultPositionScale = 2.5;
defaultVelocityOffset = 0.5;
defaultVelocityScale = 0.5;
defaultAccelerationOffset = 0.5;
defaultAccelerationScale = 0.5;
