	function FlagSineWaves(){
	  time += 0.1;
          time %= 6.28;
	  sineWaveProgram.setSrcField(this.posTexture);
          sineWaveProgram.setDstField(this.tmpTexture); 
          sineWaveProgram.use();
          sineWaveProgram.setTime(time);        
          sineWaveProgram.execute();
	}
	
	function FlagApplyGravitationalAcceleration(dstAccelerationField){
	  resetProgram.use();
          resetProgram.setValue(0.0, -9.81, 0.0);
          resetProgram.setDstField(dstAccelerationField);      
          resetProgram.execute();
	}
	
	function FlagApplyParallelAcceleration(positionField, velocityField, accelerationField){
	  var tmpField = this.tmpField;
          interalParallelAccelerationProgram.use();
          interalParallelAccelerationProgram.setSrcField(accelerationField);
          interalParallelAccelerationProgram.setDstField(tmpField);
          interalParallelAccelerationProgram.setPositionField(positionField);
          interalParallelAccelerationProgram.setVelocityField(velocityField);
          interalParallelAccelerationProgram.setSpringFactor(springConstantStructural);
          interalParallelAccelerationProgram.setDampingFactor(dampingCoeficientStructural);
          interalParallelAccelerationProgram.setSpacing(this.textureSpacing, this.textureSpacing);
          interalParallelAccelerationProgram.setNeutralDistance(this.spacing);
          interalParallelAccelerationProgram.execute();
          swapFieldRefs(accelerationField, tmpField);
	}
	
	function FlagApplyDiagonalAcceleration(positionField, velocityField, accelerationField){
	  var tmpField = this.tmpField;
	  var diagonalDistance = Math.sqrt(2.0) * this.spacing;   
          interalDiagonalAccelerationProgram.use();
          interalDiagonalAccelerationProgram.setSrcField(accelerationField);
          interalDiagonalAccelerationProgram.setDstField(tmpField);
          interalDiagonalAccelerationProgram.setPositionField(positionField);
          interalDiagonalAccelerationProgram.setVelocityField(velocityField);
          interalDiagonalAccelerationProgram.setSpringFactor(springConstantShear);
          interalDiagonalAccelerationProgram.setDampingFactor(dampingCoeficientShear);
          interalDiagonalAccelerationProgram.setSpacing(this.textureSpacing, this.textureSpacing);
          interalDiagonalAccelerationProgram.setNeutralDistance(diagonalDistance);
          interalDiagonalAccelerationProgram.execute();
          swapFieldRefs(accelerationField, tmpField);
	}
	
	function FlagApplyCurlAcceleration(positionField, velocityField, accelerationField){
	  var tmpField = this.tmpField;
          var spacing2 = this.spacing * 2.0;
          var textureSpacing2 = this.textureSpacing * 2.0;
          interalParallelAccelerationProgram.use();
          interalParallelAccelerationProgram.setSrcField(accelerationField);
          interalParallelAccelerationProgram.setDstField(tmpField);
          interalParallelAccelerationProgram.setPositionField(positionField);
          interalParallelAccelerationProgram.setVelocityField(velocityField);
          interalParallelAccelerationProgram.setSpringFactor(springConstantBend);
          interalParallelAccelerationProgram.setDampingFactor(dampingCoeficientBend);
          interalParallelAccelerationProgram.setSpacing(textureSpacing2, textureSpacing2);
          interalParallelAccelerationProgram.setNeutralDistance(spacing2);
          interalParallelAccelerationProgram.execute();
          swapFieldRefs(accelerationField, tmpField);
	}
	
	function FlagApplyWindAcceleration(positionField, velocityField, accelerationField){
           var tmpField = this.tmpField;
	   exteralAccelerationProgram.use();
	   exteralAccelerationProgram.setPositionField(positionField);
	   exteralAccelerationProgram.setVelocityField(velocityField);
	   exteralAccelerationProgram.setDstField(this.windField);
	   exteralAccelerationProgram.setSpacing(this.textureSpacing, this.textureSpacing);
           exteralAccelerationProgram.setWindVector(windSpeed, 0.0, 0.0);
           exteralAccelerationProgram.setDragCoeficient(windCoeficient);
           exteralAccelerationProgram.execute();
          
           textureOffsetProgram.use();
           textureOffsetProgram.setOffset(this.textureSpacing * 0.5, this.textureSpacing * 0.5);
           textureOffsetProgram.setDstField(tmpField);
           textureOffsetProgram.setAccelerationField(accelerationField);
           textureOffsetProgram.setWindAccelerationField(this.windField);
           textureOffsetProgram.execute();
           swapFieldRefs(accelerationField, tmpField);
	 }

	 function FlagComputeAcceleration(positionField, velocityField, dstAccelerationField){
	 	 
           this.applyGravitationalAcceleration(dstAccelerationField);
           this.applyParallelAcceleration(positionField, velocityField, dstAccelerationField);
           this.applyDiagonalAcceleration(positionField, velocityField, dstAccelerationField);
           this.applyCurlAcceleration(positionField, velocityField, dstAccelerationField);
           this.applyWindAcceleration(positionField, velocityField, dstAccelerationField);
	 }
	 
	function preCompute(){
	  gl.disable(gl.DEPTH_TEST);
	  gl.bindFramebuffer(gl.FRAMEBUFFER, FBO);
	  gl.bindBuffer(gl.ARRAY_BUFFER, rectVBO);
	  gl.vertexAttribPointer(posAttribute, 2, gl.BYTE, false, 0, 0); 
        }
  
        function postCompute(){
          gl.bindFramebuffer(gl.FRAMEBUFFER, null);
          gl.enable(gl.DEPTH_TEST);
        }
        
        function FlagComputeNormals(){
          normalsProgram.use();
	  normalsProgram.setPositionField(this.positionField);
	  normalsProgram.setDstField(this.tmpField);
	  normalsProgram.setSpacing(this.textureSpacing, this.textureSpacing);
	  normalsProgram.execute();
	  swapFieldRefs(this.normalField, this.tmpField);
          //this.normalTexture = this.swapTmpTexture(this.normalTexture);
        }

        var cnt = 0;
        var timeCnt = 0.0;
	function FlagCompute(){
	  preCompute();
	  gl.viewport(0, 0, this.size, this.size);
          // 
          var curTime = new Date().getTime();
          var timeVal = curTime - lastTime;
                      if(debugFPS && debugMode){
          cnt += 1;
          timeCnt += timeVal;
          if(cnt == 60){
            cnt = 0;
            var fps = 60000.0 / (timeCnt);
            console.log("FPS: " + fps);         
            timeCnt = 0;
          }
          }
          if(timeVal > 20){
           timeVal = 20;
          }
          var steps = cfgStepsPerFrame;
          timeVal /= (1000.0 * steps);
          if(timeVal > 0.01) timeVal = 0.01;
          lastTime = curTime;
           
          for(var i = 0; i < steps; ++i){
            this.integrator.integrate(timeVal);    
            //this.eulerIteration(timeVal);
          }
           
          // normals
          this.computeNormals();
          
          postCompute();
	}

