function Euler(){
}

function initEulerDef(){
  Euler.prototype.init = initEuler;
  Euler.prototype.integrate = integrateEulerNSV;
  Euler.prototype.integrate1 = integrateVelocityEulerNSV;
  Euler.prototype.integrate2 = integrateAccelerationEulerNSV;
}

function initEuler(flag){
  this.flag = flag;
}

function integrateEulerNSV(dt){	
   var flag = this.flag;
   
   var positionField = flag.positionField;
   var velocityField = flag.velocityField;
   var accelerationField = flag.accelerationField;
   var tmpField = flag.tmpField;
   
   var size = flag.size;
	
   gl.enable(gl.SCISSOR_TEST);
   gl.scissor(0, 0, 1, size);
   clearField(tmpField);
   gl.scissor(1, 0, size - 1, size);
          
   flag.computeAcceleration(positionField, velocityField, accelerationField);
   this.integrate1(positionField, velocityField, accelerationField, tmpField, dt);
   gl.disable(gl.SCISSOR_TEST);  
   this.integrate2(positionField, velocityField, accelerationField, tmpField, dt);
}

function integrateAccelerationEulerNSV(positionField, velocityField, accelerationField, tmpField, dt){
   eulerIntegrationProgram.use();
   eulerIntegrationProgram.setSrcField(velocityField);
   eulerIntegrationProgram.setDerivativeField(accelerationField);
   eulerIntegrationProgram.setDstField(tmpField);
   eulerIntegrationProgram.setTime(dt);
   eulerIntegrationProgram.execute();
   swapFieldRefs(velocityField, tmpField);
}

function integrateVelocityEulerNSV(positionField, velocityField, accelerationField, tmpField, dt){
   eulerIntegrationProgram.use();
   eulerIntegrationProgram.setSrcField(positionField);
   eulerIntegrationProgram.setDerivativeField(velocityField);
   eulerIntegrationProgram.setDstField(tmpField);
   eulerIntegrationProgram.execute();
   swapFieldRefs(positionField, tmpField);
}
