// Integration using Runge–Kutta

function RK4(){
}

function RK4InitDef(){
  RK4.prototype.init = RK4Init;
  RK4.prototype.initTextures = RK4InitTextures;
  RK4.prototype.getAcceleration = RK4GetAcceleration;
  RK4.prototype.getStep = RK4GetStep;
  RK4.prototype.integrate = RK4Integrate;
}

function RK4Init(flag){
  this.flag = flag;
  this.initTextures(this.flag.size);
}

function RK4InitTextures(size){
  //this.dxTexture1  // velocity 1
  this.dxField2 = createFieldRef(size);  // velocity 2
  this.dxField3 = createFieldRef(size);  // velocity 3
  this.dxField4 = createFieldRef(size);  // velocity 4	
	
  this.dvField1 = createFieldRef(size);  // acceleration 1
  this.dvField2 = createFieldRef(size);  // acceleration 2
  this.dvField3 = createFieldRef(size);  // acceleration 3
  this.dvField4 = createFieldRef(size);  // acceleration 4
  
  this.tmpField = createFieldRef(size);
}

function RK4GetAcceleration(position, velocity, dstAcceleration){
  flag.computeAcceleration(position, velocity, dstAcceleration);
}

function RK4GetStep(position, velocity, dx, dv, dt, dstVelocity, dstAcceleration){
          eulerIntegrationProgram.use();
          eulerIntegrationProgram.setSrcField(position);
          eulerIntegrationProgram.setDerivativeField(dx);
          eulerIntegrationProgram.setDstField(this.tmpField); // nemůžu použít tempField
          eulerIntegrationProgram.setTime(dt);
          eulerIntegrationProgram.execute();
          
          eulerIntegrationProgram.setSrcField(velocity);
          eulerIntegrationProgram.setDerivativeField(dv);
          eulerIntegrationProgram.setDstField(dstVelocity);
          eulerIntegrationProgram.execute();
          
          this.getAcceleration(this.tmpField, dstVelocity, dstAcceleration);        
}

function RK4Integrate(dt){
  var flag = this.flag;	 
	
  var positionField = flag.positionField;
  var velocityField = flag.velocityField; // = dxField1
  var tmpField = flag.tmpField;
  
  var size = flag.size;
  
  
  gl.enable(gl.SCISSOR_TEST);
  gl.scissor(0, 0, 1, size);
  clearField(velocityField);
  clearField(tmpField);
  
   textureOffsetProgram.use();
   textureOffsetProgram.setOffset(0.0, 0.0);
   textureOffsetProgram.setDstField(this.tmpField);
   textureOffsetProgram.setAccelerationField(tmpField);
   textureOffsetProgram.setWindAccelerationField(positionField);
   textureOffsetProgram.execute();
           
  gl.scissor(1, 0, size - 1, size);
  //
  this.getAcceleration(positionField, velocityField,  this.dvField1);
  
  var halfDt = 0.5 * dt;
  this.getStep(positionField, velocityField, velocityField, this.dvField1, halfDt, this.dxField2, this.dvField2);
  this.getStep(positionField, velocityField, this.dxField2, this.dvField2, halfDt, this.dxField3, this.dvField3);
  this.getStep(positionField, velocityField, this.dxField3, this.dvField3, dt, this.dxField4, this.dvField4);
   gl.disable(gl.SCISSOR_TEST);
  
  RK4IntegrationProgram.use();
  RK4IntegrationProgram.setSrcField(positionField);
  RK4IntegrationProgram.setDstField(tmpField);
  RK4IntegrationProgram.setK1Field(velocityField);
  RK4IntegrationProgram.setK2Field(this.dxField2);
  RK4IntegrationProgram.setK3Field(this.dxField3);
  RK4IntegrationProgram.setK4Field(this.dxField4);
  RK4IntegrationProgram.setTime(dt);
  RK4IntegrationProgram.execute();
  swapFieldRefs(positionField, tmpField);

  RK4IntegrationProgram.setSrcField(velocityField);
  RK4IntegrationProgram.setDstField(tmpField);
  RK4IntegrationProgram.setK1Field(this.dvField1);
  RK4IntegrationProgram.setK2Field(this.dvField2);
  RK4IntegrationProgram.setK3Field(this.dvField3);
  RK4IntegrationProgram.setK4Field(this.dvField4);
  RK4IntegrationProgram.execute();
  swapFieldRefs(velocityField, tmpField);
}


