window.onload = init;
  var flag;
  var time = 0.0;
  var simulationEnabled = cfgSimulationEnabled;
//
  var vertexTexture;
  var useFloat;
  var textureFloatExtension;
  var FBO;
//
  var gridVBO;
  var posTextureFloat;
  var normalTexture;
//
  var lastTime;
  var showGrid;
//
  var posAttribute = 0;
  var normalAttribute = 1;

  function init() {
    computeCorrectedValues();
    canvas = document.getElementById("c"); 
    gl = WebGLUtils.setupWebGL(canvas);
    if (!gl) {
      return;
    }
    if(debugMode && useWebGLDebugContext){
        gl = WebGLDebugUtils.makeDebugContext(gl);   
    }
    if(debugMode && useWebGLDebugUtils){
        WebGLDebugUtils.init(gl);   
    }
    width = canvas.width;
    height = canvas.height; 
    FBO = gl.createFramebuffer();
    checkExtensions();
    initMatrixes();
    initGlResourceUtil();
    try {
      initShaders();   
      initPrograms();
    } catch(err){
      console.log("shaders/programs error");
      return;
    }
    updateMatrixes();
    gl.viewport(0, 0, canvas.width, canvas.height);
    gl.clearColor(0.0, 0.0, 0.0, 1.0);
    gl.clear(gl.COLOR_BUFFER_BIT);
    
    gl.enable(gl.DEPTH_TEST);
    //gl.depthFunc(gl.LEQUAL);
    //gl.polygonOffset(1.0, 1.0);
    //gl.enable(gl.POLYGON_OFFSET_FILL);   
    gl.enableVertexAttribArray(posAttribute);
    console.log("flagdef");
    prepareFlagDef();
    RK4InitDef();
    initEulerDef();
    initNSVDef();
    initSineWaveDef();
    flag = new Flag(flagLog2Size);
    console.log("flag");
    flag.init();
    
    initInputEvents();
    
    lastTime = new Date().getTime();
    render();
  }

  function render() {
    window.requestAnimFrame(render, canvas);
    if(simulationEnabled){
      flag.compute();
      if(cfgStepping){
        simulationEnabled = false;
      }
    }
    flag.render();
    //gl.finish();
  }
  
  function checkSupportedExtensions(){
      if(debugMode && debugSupportedExtensionsList){
          console.log("SupportedExtensions: ");
          var extensions = gl.getSupportedExtensions();
          if(extensions){
              for(var i = 0; i < extensions.length; ++i){
                  console.log(extensions[i]+"\n");
              }
          }
          console.log("\n");
      }
  }
    
  function checkExtensions(){
     checkSupportedExtensions();
     checkExtensionsSectionDebug();
     textureFloatExtension = gl.getExtension('OES_texture_float');
     checkExtensionsDebug("supports FLOAT texture: " + (textureFloatExtension != null));
     
     if(textureFloatExtension && !textureFloatDisable){
       var testTexture = createTexture(1, gl.NEAREST, gl.RGB, gl.FLOAT);
       gl.bindFramebuffer(gl.FRAMEBUFFER, FBO);
       gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, testTexture, 0);
       var status = gl.checkFramebufferStatus(gl.FRAMEBUFFER);
       gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, null, 0);
       gl.bindFramebuffer(gl.FRAMEBUFFER, null);
       gl.deleteTexture(testTexture);
       var supportsFloatRTT = status == gl.FRAMEBUFFER_COMPLETE;
       checkExtensionsDebug("supports rendering to FLOAT texture: " + supportsFloatRTT);
       useFloat = supportsFloatRTT;
     } else {
       useFloat = false;  
     }
     checkExtensionsDebug("using FLOAT texture: " + useFloat);
     var units = gl.getParameter(gl.MAX_VERTEX_TEXTURE_IMAGE_UNITS);
     checkExtensionsDebug("MAX_VERTEX_TEXTURE_IMAGE_UNITS: " + units);
     vertexTexture = (useFloat ? units >= 2 : units >= 4) && !vertexTextureDisable;
     checkExtensionsDebug("using vertex texture: " + vertexTexture);
     checkExtensionsGLErrorDebug();
     checkExtensionsDebug("\n");
  }
  
  

