/////////////
// SHADERS //
/////////////


  // VERTEX
  var computeVS;
  var renderingVS;
  
  // FRAGMENT
  var initialFS;
  var sineWaveFS; // for testing
  var resetFS;
  var interalParallelAccelerationFS;
  var interalDiagonalAccelerationFS;
  var exteralAccelerationFS;
  var eulerIntegrationFS;
  var RK4IntegrationFS;
  var AddAndMulFS;
  var textureOffsetFS;
  var scaleFS;
  var normalFS;
  var renderingFS;
  var testRenderingFS; // for testing
    
  function initShaders(){
     shadersSectionDebug();
     // VERTEX
     shadersDebug("computeVS");
     computeVS = createShader(getSrcComputeVS(), gl.VERTEX_SHADER);
     shadersDebug("renderingVS");
     renderingVS = createShader(getSrcRenderingVS(), gl.VERTEX_SHADER);
     // FRAGMENT
     shadersDebug("initialFS");
     initialFS = createShader(getSrcInitialPositionsFS(), gl.FRAGMENT_SHADER);  
     shadersDebug("sineWaveFS");
     sineWaveFS = createShader(getSrcSineWavePositionsFS(), gl.FRAGMENT_SHADER);
     shadersDebug("resetFS");
     resetFS = createShader(getSrcResetFS(), gl.FRAGMENT_SHADER);
     if(useFloat){
       shadersDebug("interalParallelAccelerationFS");
       interalParallelAccelerationFS = createShader(getSrcInteralAccelerationFS(true), gl.FRAGMENT_SHADER);
       shadersDebug("interalDiagonalAccelerationFS");
       interalDiagonalAccelerationFS = createShader(getSrcInteralAccelerationFS(false), gl.FRAGMENT_SHADER);
     }
     shadersDebug("exteralAccelerationsFS");
     exteralAccelerationFS = createShader(getSrcExteralAccelerationFS(), gl.FRAGMENT_SHADER);
     shadersDebug("scaleFS");
     scaleFS = createShader(getSrcScaleFS(), gl.FRAGMENT_SHADER);
     shadersDebug("textureOffsetFS");
     textureOffsetFS = createShader(getSrcTextureOffsetFS(), gl.FRAGMENT_SHADER);
     shadersDebug("eulerIntegrationFS");
     eulerIntegrationFS = createShader(getSrcEulerIntegrationFS(), gl.FRAGMENT_SHADER);
     if(useFloat){
       shadersDebug("RK4IntegrationFS");
       RK4IntegrationFS = createShader(getSrcRK4IntegrationFS(), gl.FRAGMENT_SHADER);
     }
     shadersDebug("AddAndMulFS");
     AddAndMulFS = createShader(getSrcAddAndMulFS(), gl.FRAGMENT_SHADER);
     shadersDebug("normalFS");
     normalFS = createShader(getSrcNormalFS(), gl.FRAGMENT_SHADER); 
     shadersDebug("renderingFS");
     renderingFS = createShader(getSrcRenderingFS(), gl.FRAGMENT_SHADER);
  }
  
  function createShader(source, type){
    shadersSourceDebug(source);
    var shader = gl.createShader(type); 
    gl.shaderSource(shader, source);
    gl.compileShader(shader);
    shadersTypeDebug(shader);
    var status = gl.getShaderParameter(shader, gl.COMPILE_STATUS);
    shadersCompileStatusDebug(status);
    shadersInfoLogDebug(shader);
    shadersGLErrorDebug();
    shadersDebug("\n\n");
    if(!status){
      throw "Compilation of shader failed"
    }
    return shader;
  }
  






